Index: trunk/NEMO/OPA_SRC/TRD/trdmod.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 503)
@@ -4,23 +4,31 @@
    !! Ocean diagnostics:  ocean tracers and dynamic trends
    !!=====================================================================
+   !! History :  9.0  !  04-08  (C. Talandier) Original code
+   !!                 !  05-04  (C. Deltel)    Add Asselin trend in the ML budget
+   !!----------------------------------------------------------------------
 #if  defined key_trdtra || defined key_trddyn || defined key_trdmld || defined key_trdvor || defined key_esopa
    !!----------------------------------------------------------------------
    !!   trd_mod          : Call the trend to be computed
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !!   trd_mod_init     : Initialization step
+   !!----------------------------------------------------------------------
+   USE phycst                  ! physical constants
    USE oce                     ! ocean dynamics and tracers variables
    USE dom_oce                 ! ocean space and time domain variables
+   USE zdf_oce                 ! ocean vertical physics variables
    USE trdmod_oce              ! ocean variables trends
+   USE ldftra_oce              ! ocean active tracers lateral physics
    USE trdvor                  ! ocean vorticity trends 
    USE trdicp                  ! ocean bassin integral constraints properties
    USE trdmld                  ! ocean active mixed layer tracers trends 
-   USE trabbl                  ! bottom boundary layer variables
    USE in_out_manager          ! I/O manager
+   USE taumod                  ! surface ocean stress
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC trd_mod        ! called by all dynXX or traXX modules
+   REAL(wp) ::   r2dt          ! time-step, = 2 rdttra except at nit000 (=rdttra) if neuler=0
+
+   PUBLIC trd_mod              ! called by all dynXX or traXX modules
+   PUBLIC trd_mod_init         ! called by opa.F90 module
 
    !! * Substitutions
@@ -30,104 +38,117 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE trd_mod(ptrdx, ptrdy, ktrd, ctype, kt)
+   SUBROUTINE trd_mod( ptrdx, ptrdy, ktrd, ctype, kt, cnbpas )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mod  ***
       !! 
       !! ** Purpose : Dispatch all trends computation, e.g. vorticity, mld or 
-      !!              integral constrains
+      !!              integral constraints
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt                                ! time step
+      INTEGER, INTENT( in ) ::   ktrd                              ! tracer trend index
+      CHARACTER(len=3), INTENT( in ) ::   ctype                    ! momentum or tracers trends type 'DYN'/'TRA'
+      CHARACTER(len=3), INTENT( in ), OPTIONAL ::   cnbpas         ! number of passage
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   ptrdx ! Temperature or U trend 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   ptrdy ! Salinity    or V trend
       !!
-      !! ** Method :
-      !!
-      !! History :
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Modules used
-#if defined key_trabbl_adv
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  &  ! temporary arrays
-         &         zun, zvn
-#else
-      USE oce                , zun => un,  &  ! When no bbl, zun == un
-         &                     zvn => vn      ! When no bbl, zvn == vn
-#endif
-
-      !! * Arguments
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
-         ptrdx,                      &   ! Temperature or U trend 
-         ptrdy                           ! Salinity    or V trend
-
-      INTEGER, INTENT( in ) ::   &
-         kt  ,                   & ! time step
-         ktrd                      ! tracer trend index
-
-      CHARACTER(len=3), INTENT( in ) ::   &
-         ctype                             ! momentum or tracers trends type
-         !                                 ! 'DYN' or 'TRA'
-
-      !! * Local save
-      REAL(wp), DIMENSION(jpi,jpj), SAVE ::   &
-         zbtr2
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk    ! loop indices
-      REAL(wp) ::   &
-         zbtr,            &  ! temporary scalars
-         zfui, zfvj,           &  !    "         "
-         zfui1, zfvj1             !    "         "
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         z2dx, z2dy                        ! workspace arrays
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         z3dx, z3dy                            ! workspace arrays
-      !!----------------------------------------------------------------------
-
-      ! Initialization of workspace arrays
-      z3dx(:,:,:) = 0.e0
-      z3dy(:,:,:) = 0.e0
-      z2dx(:,:) = 0.e0
-      z2dy(:,:) = 0.e0
+      INTEGER ::   ji, ikbu, ikbum1
+      INTEGER ::   jj, ikbv, ikbvm1
+      CHARACTER(len=3) ::   clpas                                  ! number of passage
+      REAL(wp) ::   zua, zva                                       ! scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztswu, ztswv               ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztbfu, ztbfv               ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   z2dx, z2dy                 ! workspace arrays
+      !!----------------------------------------------------------------------
+
+      z2dx(:,:)   = 0.e0   ;   z2dy(:,:)   = 0.e0                  ! initialization of workspace arrays
+
+      ! Control of optional arguments
+      clpas = 'fst'
+      IF( PRESENT(cnbpas) )  clpas = cnbpas
+
+      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (restarting with Euler time stepping)
+      ELSEIF(               kt <= nit000 + 1) THEN   ;   r2dt = 2. * rdt      ! = 2 rdttra (leapfrog)
+      ENDIF
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! I. Bassin averaged properties for momentum and/or tracers trends
+      ! I. Integral Constraints Properties for momentum and/or tracers trends
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
       IF( ( mod(kt,ntrd) == 0 .OR. kt == nit000 .OR. kt == nitend) )   THEN
-
-         ! Active tracers trends 
-         IF( lk_trdtra .AND. ctype == 'TRA' )   THEN
-
-            IF( ktrd == jpttdnsr )   THEN
-               ! 2D array tracers surface forcing
-               z2dx(:,:) = ptrdx(:,:,1)
-               z2dy(:,:) = ptrdy(:,:,1)
-
-               CALL trd(z2dx, z2dy, ktrd, ctype)
-            ELSE
-               ! 3D array
-               CALL trd(ptrdx, ptrdy, ktrd, ctype)
-            ENDIF
-
-         ENDIF
-
-         ! Momentum trends 
-         IF( lk_trddyn .AND. ctype == 'DYN' )   THEN
-
-            IF( ktrd == jpdtdswf .OR. ktrd == jpdtdbfr )   THEN
-               ! momentum surface forcing/bottom friction  2D array
-               z2dx(:,:) = ptrdx(:,:,1)
-               z2dy(:,:) = ptrdy(:,:,1)
-
-               CALL trd(z2dx, z2dy, ktrd, ctype)
-            ELSE
-               ! 3D array
-               CALL trd(ptrdx, ptrdy, ktrd, ctype)
-            ENDIF
-
-         ENDIF
-
-      ENDIF
+         !
+         IF( lk_trdtra .AND. ctype == 'TRA' )   THEN       ! active tracer trends
+            SELECT CASE ( ktrd )
+            CASE ( jptra_trd_ldf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_ldf, ctype )   ! lateral diff
+            CASE ( jptra_trd_zdf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_zdf, ctype )   ! vertical diff (Kz)
+            CASE ( jptra_trd_bbc )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_bbc, ctype )   ! bottom boundary cond
+            CASE ( jptra_trd_bbl )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_bbl, ctype )   ! bottom boundary layer
+            CASE ( jptra_trd_npc )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_npc, ctype )   ! static instability mixing
+            CASE ( jptra_trd_dmp )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_dmp, ctype )   ! damping
+            CASE ( jptra_trd_qsr )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_qsr, ctype )   ! penetrative solar radiat.
+            CASE ( jptra_trd_nsr )   
+               z2dx(:,:) = ptrdx(:,:,1)   ;   z2dy(:,:) = ptrdy(:,:,1)
+               CALL trd_icp( z2dx, z2dy, jpicpt_nsr, ctype )                               ! non solar radiation
+            CASE ( jptra_trd_xad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_xad, ctype )   ! x- horiz adv
+            CASE ( jptra_trd_yad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_yad, ctype )   ! y- horiz adv
+            CASE ( jptra_trd_zad )                                                         ! z- vertical adv 
+               CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype, clpas )   
+               ! compute the surface flux condition wn(:,:,1)*tn(:,:,1)                                                                   
+               z2dx(:,:) = wn(:,:,1)*tn(:,:,1)/fse3t(:,:,1)   
+               z2dy(:,:) = wn(:,:,1)*sn(:,:,1)/fse3t(:,:,1)
+               CALL trd_icp( z2dx , z2dy , jpicpt_zl1, ctype )                             ! 1st z- vertical adv 
+            END SELECT
+         END IF
+
+         IF( lk_trddyn .AND. ctype == 'DYN' )   THEN       ! momentum trends 
+            !
+            SELECT CASE ( ktrd )
+            CASE ( jpdyn_trd_hpg )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_hpg, ctype )   ! hydrost. pressure grad
+            CASE ( jpdyn_trd_keg )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_keg, ctype )   ! KE gradient 
+            CASE ( jpdyn_trd_rvo )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_rvo, ctype )   ! relative vorticity 
+            CASE ( jpdyn_trd_pvo )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_pvo, ctype )   ! planetary vorticity
+            CASE ( jpdyn_trd_ldf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_ldf, ctype )   ! lateral diffusion 
+            CASE ( jpdyn_trd_zad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_zad, ctype )   ! vertical advection 
+            CASE ( jpdyn_trd_spg )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_spg, ctype )   ! surface pressure grad.
+            CASE ( jpdyn_trd_dat )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpd_dat, ctype )   ! damping term
+            CASE ( jpdyn_trd_zdf )                                                         ! vertical diffusion 
+               ! subtract surface forcing/bottom friction trends 
+               ! from vertical diffusive momentum trends
+               ztswu(:,:) = 0.e0   ;   ztswv(:,:) = 0.e0
+               ztbfu(:,:) = 0.e0   ;   ztbfv(:,:) = 0.e0  
+               DO jj = 2, jpjm1   
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     ! save the surface forcing momentum fluxes
+                     ztswu(ji,jj) = taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
+                     ztswv(ji,jj) = tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
+                     ! save bottom friction momentum fluxes
+                     ikbu   = MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) )
+                     ikbv   = MIN( mbathy(ji  ,jj+1), mbathy(ji,jj) )
+                     ikbum1 = MAX( ikbu-1, 1 )
+                     ikbvm1 = MAX( ikbv-1, 1 )
+                     zua = ua(ji,jj,ikbum1) * r2dt + ub(ji,jj,ikbum1)
+                     zva = va(ji,jj,ikbvm1) * r2dt + vb(ji,jj,ikbvm1)
+                     ztbfu(ji,jj) = - avmu(ji,jj,ikbu) * zua / ( fse3u(ji,jj,ikbum1)*fse3uw(ji,jj,ikbu) )
+                     ztbfv(ji,jj) = - avmv(ji,jj,ikbv) * zva / ( fse3v(ji,jj,ikbvm1)*fse3vw(ji,jj,ikbv) )
+                     !
+                     ptrdx(ji,jj,1     ) = ptrdx(ji,jj,1     ) - ztswu(ji,jj)
+                     ptrdy(ji,jj,1     ) = ptrdy(ji,jj,1     ) - ztswv(ji,jj)
+                     ptrdx(ji,jj,ikbum1) = ptrdx(ji,jj,ikbum1) - ztbfu(ji,jj)
+                     ptrdy(ji,jj,ikbvm1) = ptrdy(ji,jj,ikbvm1) - ztbfv(ji,jj)
+                  END DO
+               END DO
+               !
+               CALL trd_icp( ptrdx, ptrdy, jpicpd_zdf, ctype )   
+               CALL trd_icp( ztswu, ztswv, jpicpd_swf, ctype )                               ! wind stress forcing term
+               CALL trd_icp( ztbfu, ztbfv, jpicpd_bfr, ctype )                               ! bottom friction term
+            END SELECT
+            !
+         END IF
+         !
+      END IF
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -136,276 +157,87 @@
 
       IF( lk_trdvor .AND. ctype == 'DYN' )   THEN
-
-         SELECT CASE ( ktrd )
-
-         ! Pressure Gradient trend
-         CASE ( jpdtdhpg )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorprg)
-
-         ! KE Gradient trend
-         CASE ( jpdtdkeg )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorkeg)
-
-         ! Relative Vorticity trend
-         CASE ( jpdtdrvo )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorrvo)
-
-         ! Planetary Vorticity Term trend
-         CASE ( jpdtdpvo )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorpvo)
-
-         ! Horizontal Diffusion trend
-         CASE ( jpdtdldf )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorldf)
-
-         ! Vertical Advection trend
-         CASE ( jpdtdzad )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorzad)
-
-         ! Vertical Diffusion trend
-         CASE ( jpdtdzdf )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorzdf)
-
-         ! Surface Pressure Grad. trend
-         CASE ( jpdtdspg )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorspg)
-
-         ! Beta V trend 
-         CASE ( jpdtddat )      
-            CALL trd_vor_zint(ptrdx, ptrdy, jpvorbev)
-
-         ! Wind stress forcing term
-         CASE ( jpdtdswf )      
-            z2dx(:,:) = ptrdx(:,:,1)
-            z2dy(:,:) = ptrdy(:,:,1)
-
-            CALL trd_vor_zint(z2dx, z2dy, jpvorswf)
-
-         ! Bottom friction term
-         CASE ( jpdtdbfr )      
-            z2dx(:,:) = ptrdx(:,:,1)
-            z2dy(:,:) = ptrdy(:,:,1)
-
-            CALL trd_vor_zint(z2dx, z2dy, jpvorbfr)
-
+         !
+         SELECT CASE ( ktrd ) 
+         CASE ( jpdyn_trd_hpg )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_prg )   ! Hydrostatique Pressure Gradient 
+         CASE ( jpdyn_trd_keg )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_keg )   ! KE Gradient 
+         CASE ( jpdyn_trd_rvo )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_rvo )   ! Relative Vorticity 
+         CASE ( jpdyn_trd_pvo )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_pvo )   ! Planetary Vorticity Term 
+         CASE ( jpdyn_trd_ldf )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_ldf )   ! Horizontal Diffusion 
+         CASE ( jpdyn_trd_zad )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_zad )   ! Vertical Advection 
+         CASE ( jpdyn_trd_spg )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_spg )   ! Surface Pressure Grad. 
+         CASE ( jpdyn_trd_dat )   ;   CALL trd_vor_zint( ptrdx, ptrdy, jpvor_bev )   ! Beta V  
+         CASE ( jpdyn_trd_zdf )                                                      ! Vertical Diffusion 
+            ! subtract surface forcing/bottom friction trends 
+            ! from vertical diffusive momentum trends
+            ztswu(:,:) = 0.e0   ;   ztswv(:,:) = 0.e0
+            ztbfu(:,:) = 0.e0   ;   ztbfv(:,:) = 0.e0  
+            DO jj = 2, jpjm1   
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  ! save the surface forcing momentum fluxes
+                  ztswu(ji,jj) = taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
+                  ztswv(ji,jj) = tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
+                  ! save bottom friction momentum fluxes
+                  ikbu   = MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) )
+                  ikbv   = MIN( mbathy(ji  ,jj+1), mbathy(ji,jj) )
+                  ikbum1 = MAX( ikbu-1, 1 )
+                  ikbvm1 = MAX( ikbv-1, 1 )
+                  zua = ua(ji,jj,ikbum1) * r2dt + ub(ji,jj,ikbum1)
+                  zva = va(ji,jj,ikbvm1) * r2dt + vb(ji,jj,ikbvm1)
+                  ztbfu(ji,jj) = - avmu(ji,jj,ikbu) * zua / ( fse3u(ji,jj,ikbum1)*fse3uw(ji,jj,ikbu) )
+                  ztbfv(ji,jj) = - avmv(ji,jj,ikbv) * zva / ( fse3v(ji,jj,ikbvm1)*fse3vw(ji,jj,ikbv) )
+                  !
+                  ptrdx(ji,jj,1     ) = ptrdx(ji,jj,1     ) - ztswu(ji,jj)
+                  ptrdx(ji,jj,ikbum1) = ptrdx(ji,jj,ikbum1) - ztbfu(ji,jj)
+                  ptrdy(ji,jj,1     ) = ptrdy(ji,jj,1     ) - ztswv(ji,jj)
+                  ptrdy(ji,jj,ikbvm1) = ptrdy(ji,jj,ikbvm1) - ztbfv(ji,jj)
+               END DO
+            END DO
+            !
+            CALL trd_vor_zint( ptrdx, ptrdy, jpvor_zdf )   
+            CALL trd_vor_zint( ztswu, ztswv, jpvor_swf )                               ! Wind stress forcing term
+            CALL trd_vor_zint( ztbfu, ztbfv, jpvor_bfr )                               ! Bottom friction term
          END SELECT
-
+         !
       ENDIF
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! III. Mixed layer trends
+      ! III. Mixed layer trends for active tracers
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
       IF( lk_trdmld .AND. ctype == 'TRA' )   THEN
          
+         !-----------------------------------------------------------------------------------------------
+         ! W.A.R.N.I.N.G :
+         ! jptra_trd_ldf : called by traldf.F90
+         !                 at this stage we store:
+         !                  - the lateral geopotential diffusion (here, lateral = horizontal)
+         !                  - and the iso-neutral diffusion if activated 
+         ! jptra_trd_zdf : called by trazdf.F90
+         !                 * in case of purely vertical diffusion (and not iso-neutral),
+         !                   we do not need to store the corresponding trend here, since it
+         !                   is recomputed later (at the basis of the ML, see trd_mld)
+         !                 * else (iso-neutral case) we store the vertical diffusion component in the 
+         !                   lateral trend including the K_z contrib, which will be removed later (see trd_mld)
+         !-----------------------------------------------------------------------------------------------
+
          SELECT CASE ( ktrd )
-
-         ! horizontal advection trends
-         CASE ( jpttdlad )      
-
-#if defined key_trabbl_adv
-            ! Advective bottom boundary layer 
-            ! -------------------------------
-            zun(:,:,:) = un(:,:,:) - u_bbl(:,:,:)
-            zvn(:,:,:) = vn(:,:,:) - v_bbl(:,:,:)
-#endif
-            IF( kt == nit000 )   zbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
-
-            SELECT CASE ( l_adv )
-
-            CASE ( 'ce2' )
-
-               ! Split horizontal trends into i- and j- compnents for trdmld case 
-               ! ----------------------------------------------------------------
-
-               ! i- advective trend computed as Uh gradh(T)
-               DO jk = 1, jpkm1
-                  DO jj = 2, jpjm1
-                     DO ji = fs_2, fs_jpim1   ! vector opt.
-# if defined key_zco
-                        zbtr = zbtr2(ji,jj)
-                        zfui = 0.5 * e2u(ji  ,jj) * zun(ji,  jj,jk)
-                        zfui1= 0.5 * e2u(ji-1,jj) * zun(ji-1,jj,jk)
-# else         
-                        zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-                        zfui = 0.5 * e2u(ji  ,jj) * fse3u(ji,  jj,jk) * zun(ji,  jj,jk)
-                        zfui1= 0.5 * e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zun(ji-1,jj,jk)
-# endif
-                        ! save i- advective trend 
-                        z3dx(ji,jj,jk) = - zbtr * ( zfui  * ( tn(ji+1,jj,jk) - tn(ji  ,jj,jk) )    &
-                            &                     + zfui1 * ( tn(ji  ,jj,jk) - tn(ji-1,jj,jk) ) )
-                        z3dy(ji,jj,jk) = - zbtr * ( zfui  * ( sn(ji+1,jj,jk) - sn(ji  ,jj,jk) )    &
-                            &                     + zfui1 * ( sn(ji  ,jj,jk) - sn(ji-1,jj,jk) ) )
-                     END DO
-                  END DO
-               END DO
-
-               ! save the i- horizontal trends for diagnostic
-               CALL trd_mld_zint(z3dx, z3dy, jpmldxad, '3D')
-
-               ! j- advective trend computed as Uh gradh(T)
-               DO jk = 1, jpkm1
-                  DO jj = 2, jpjm1
-                     DO ji = fs_2, fs_jpim1   ! vector opt.
-# if defined key_zco
-                        zbtr = zbtr2(ji,jj)
-                        zfvj = 0.5 * e1v(ji,jj  ) * zvn(ji,jj  ,jk)
-                        zfvj1= 0.5 * e1v(ji,jj-1) * zvn(ji,jj-1,jk)
-# else         
-                        zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-                        zfvj = 0.5 * e1v(ji,jj  ) * fse3v(ji,jj  ,jk) * zvn(ji,jj  ,jk)
-                        zfvj1= 0.5 * e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * zvn(ji,jj-1,jk)
-# endif
-                        ! save j- advective trend 
-                        z3dx(ji,jj,jk) = - zbtr * ( zfvj  * ( tn(ji,jj+1,jk) - tn(ji,jj  ,jk) )   &
-                            &                     + zfvj1 * ( tn(ji,jj  ,jk) - tn(ji,jj-1,jk) ) )
-                        z3dy(ji,jj,jk) = - zbtr * ( zfvj  * ( sn(ji,jj+1,jk) - sn(ji,jj  ,jk) )   &
-                            &                     + zfvj1 * ( sn(ji,jj  ,jk) - sn(ji,jj-1,jk) ) )
-                     END DO
-                  END DO
-               END DO
-
-               ! save the j- horizontal trend for diagnostic
-               CALL trd_mld_zint(z3dx, z3dy, jpmldyad, '3D')
-
-            CASE ( 'tvd' )
-
-               ! Recompute the horizontal advection term Div(Uh.T) term 
-               z3dx(:,:,:) = ptrdx(:,:,:) - tn(:,:,:) * hdivn(:,:,:)
-               z3dy(:,:,:) = ptrdy(:,:,:) - sn(:,:,:) * hdivn(:,:,:)
-
-               ! Deduce the i- horizontal advection in substracting the j- one.
-               ! tladj()/sladj() are computed in traadv_tvd.F90 module
-               z3dx(:,:,:) = z3dx(:,:,:) - tladj(:,:,:)
-               z3dy(:,:,:) = z3dy(:,:,:) - sladj(:,:,:)
-
-               DO jk = 1, jpkm1
-                  DO jj = 2, jpjm1
-                     DO ji = fs_2, fs_jpim1
-                        zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-
-                        ! Compute the zonal et meridional divergence
-                        zfui = e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * zun(ji  ,jj,jk)  &
-                             - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zun(ji-1,jj,jk)
-                        zfvj = e1v(ji,jj  ) * fse3v(ji,jj  ,jk) * zvn(ji,jj  ,jk)  &
-                             - e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * zvn(ji,jj-1,jk)
-
-                        ! i- advective trend computed as U gradx(T/S)
-                        z3dx(ji,jj,jk) = z3dx(ji,jj,jk) + tn(ji,jj,jk) * zfui * zbtr
-                        z3dy(ji,jj,jk) = z3dy(ji,jj,jk) + sn(ji,jj,jk) * zfui * zbtr
-
-                        ! j- advective trend computed as V grady(T/S)
-                        tladj(ji,jj,jk) = tladj(ji,jj,jk) + tn(ji,jj,jk) * zfvj * zbtr
-                        sladj(ji,jj,jk) = sladj(ji,jj,jk) + sn(ji,jj,jk) * zfvj * zbtr
-
-                     END DO
-                  END DO
-               END DO
-
-               ! save the i- horizontal trend for diagnostic
-               CALL trd_mld_zint(z3dx, z3dy, jpmldxad, '3D')
-
-               ! save the j- horizontal trend for diagnostic
-               CALL trd_mld_zint(tladj, sladi, jpmldyad, '3D')
-
-            CASE ( 'mus', 'mu2' )
-
-               !  Split horizontal trends in i- and j- direction for trdmld case 
-               ! ----------------------------------------------------------------
-
-               ! i- advective trend computed as U gradx(T/S)
-               DO jk = 1, jpkm1
-                  DO jj = 2, jpjm1      
-                     DO ji = fs_2, fs_jpim1   ! vector opt.
-# if defined key_zco
-                        zbtr = zbtr2(ji,jj)
-                        zfui = e2u(ji  ,jj) * zun(ji,  jj,jk)   &
-                           & - e2u(ji-1,jj) * zun(ji-1,jj,jk)
-# else      
-                        zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-                        zfui =  e2u(ji  ,jj) * fse3u(ji,  jj,jk) * zun(ji,  jj,jk)   &
-                           & -  e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * zun(ji-1,jj,jk)
-# endif
-                        ! save i- advective trend 
-                        z3dx(ji,jj,jk) = - zbtr * ( tladi(ji,jj,jk) - tladi(ji-1,jj,jk) )   &
-                            &                      + tn(ji,jj,jk) * zfui * zbtr
-                        z3dy(ji,jj,jk) = - zbtr * ( sladi(ji,jj,jk) - sladi(ji-1,jj,jk) )  &
-                            &                      + sn(ji,jj,jk) * zfui * zbtr
-                     END DO
-                  END DO
-               END DO        
-
-               ! save the i- horizontal trends for diagnostic
-               CALL trd_mld_zint(z3dx, z3dy, jpmldxad, '3D')
-
-               ! j- advective trend computed as V grady(T/S)
-               DO jk = 1, jpkm1
-                  DO jj = 2, jpjm1      
-                     DO ji = fs_2, fs_jpim1   ! vector opt.
-# if defined key_zco
-                        zbtr = zbtr2(ji,jj)
-                        zfvj = e1v(ji,jj  ) * zvn(ji,jj  ,jk)   &
-                           & - e1v(ji,jj-1) * zvn(ji,jj-1,jk)
-# else      
-                        zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-                        zfvj =  e1v(ji,jj  ) * fse3v(ji,jj  ,jk) * zvn(ji,jj  ,jk)   &
-                           & -  e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * zvn(ji,jj-1,jk)
-# endif
-                        ! save j- advective trend 
-                        z3dx(ji,jj,jk) =  - zbtr * ( tladj(ji,jj,jk) - tladj(ji,jj-1,jk) )   &
-                            &                       + tn(ji,jj,jk) * zfvj * zbtr
-                        z3dy(ji,jj,jk) =  - zbtr * ( sladj(ji,jj,jk) - sladj(ji,jj-1,jk) )   &
-                            &                       + sn(ji,jj,jk) * zfvj * zbtr
-                     END DO
-                  END DO
-               END DO        
-
-               ! save the j- horizontal trends for diagnostic
-               CALL trd_mld_zint(z3dx, z3dy, jpmldyad, '3D')
-
-            END SELECT
-
-         ! vertical advection trends
-         CASE ( jpttdzad )      
-            CALL trd_mld_zint(ptrdx, ptrdy, jpmldzad, '3D')
-
-         ! lateral diffusion trends
-         CASE ( jpttdldf )      
-            CALL trd_mld_zint(ptrdx, ptrdy, jpmldldf, '3D')
-# if defined key_traldf_eiv
-            ! Save the i- and j- eddy induce velocity trends
-            CALL trd_mld_zint(tladi, sladi, jpmldxei, '3D')
-            CALL trd_mld_zint(tladj, sladj, jpmldyei, '3D')
-# endif
-            IF( lk_trabbl_dif )   THEN
-               z3dx(:,:,:) = 0.e0
-               z3dy(:,:,:) = 0.e0
-               z3dx(:,:,1) = tldfbbl(:,:)
-               z3dy(:,:,1) = sldfbbl(:,:)
-               CALL trd_mld_zint(z3dx, z3dy, jpmldldf, '2D')
-            ENDIF
-
-         ! vertical diffusion trends
-         CASE ( jpttdzdf )      
-            CALL trd_mld_zint(ptrdx, ptrdy, jpmldzdf, '3D')
-
-         ! vertical diffusion trends
-         CASE ( jpttddoe )      
-            CALL trd_mld_zint(ptrdx, ptrdy, jpmldzei, '3D')
-
-         ! penetrative solar radiation trends
-         CASE ( jpttdqsr )      
-            CALL trd_mld_zint(ptrdx, ptrdy, jpmldfor, '3D')
-
-         ! non penetrative solar radiation trends
-         CASE ( jpttdnsr )
-            ptrdx(:,:,2:jpk) = 0.e0
-            ptrdy(:,:,2:jpk) = 0.e0
-            CALL trd_mld_zint(ptrdx, ptrdy, jpmldfor, '2D')
-
-         END SELECT   
+         CASE ( jptra_trd_xad )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_xad, '3D' )   ! merid. advection
+         CASE ( jptra_trd_yad )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_yad, '3D' )   ! zonal  advection
+         CASE ( jptra_trd_zad )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_zad, '3D' )   ! vertical advection
+         CASE ( jptra_trd_ldf )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_ldf, '3D' )   ! lateral diffusive
+         CASE ( jptra_trd_bbl )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_bbl, '3D' )   ! bottom boundary layer
+         CASE ( jptra_trd_zdf )
+            IF( ln_traldf_iso )       CALL trd_mld_zint( ptrdx, ptrdy, jpmld_ldf, '3D' )   ! vertical diffusion (K_z)
+         CASE ( jptra_trd_dmp )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_dmp, '3D' )   ! internal 3D restoring (tradmp)
+         CASE ( jptra_trd_qsr )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_for, '3D' )   ! air-sea : penetrative sol radiat
+         CASE ( jptra_trd_nsr )
+            ptrdx(:,:,2:jpk) = 0.e0   ;   ptrdy(:,:,2:jpk) = 0.e0
+            CALL trd_mld_zint( ptrdx, ptrdy, jpmld_for, '2D' )                             ! air-sea : non penetr sol radiat
+         CASE ( jptra_trd_bbc )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_bbc, '3D' )   ! bottom bound cond (geoth flux)
+         CASE ( jptra_trd_atf )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_atf, '3D' )   ! asselin numerical
+         CASE ( jptra_trd_npc )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_npc, '3D' )   ! non penetr convect adjustment
+         END SELECT
 
       ENDIF
-
 
    END SUBROUTINE trd_mod
